function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
import { defineComponent, $prefix, $props, $setup } from "@xmweb-ui/vue-common";
import PcTemplate from "./pc.js";
import MobileTemplate from "./mobile.js";
import MobileFirstTemplate from "./mobile-first.js";
var template = function template2(mode) {
  if ("pc" === (process.env.TINY_MODE || mode)) {
    return PcTemplate;
  }
  if ("mobile" === (process.env.TINY_MODE || mode)) {
    return MobileTemplate;
  }
  if ("mobile-first" === (process.env.TINY_MODE || mode)) {
    return MobileFirstTemplate;
  }
  return PcTemplate;
};
var $constants = {
  INPUT_PC: "xm-input__",
  INPUTGROUP_PC: "xm-input-group__",
  INPUT_MOBILE: "xm-mobile-input__",
  INPUTGROUP_MOBILE: "xm-mobile-input-group__",
  Mode: "pc",
  inputMode: function inputMode(mode) {
    return mode === this.Mode ? this.INPUT_PC : this.INPUT_MOBILE;
  },
  inputGroupMode: function inputGroupMode(mode) {
    return mode === this.Mode ? this.INPUTGROUP_PC : this.INPUTGROUP_MOBILE;
  },
  VALIDATE_ICON: {
    Validating: "xm-icon-loading",
    Success: "xm-icon-circle-check",
    Error: "xm-icon-circle-close"
  },
  COMPONENT_NAME: {
    FormItem: "FormItem"
  }
};
var Input = defineComponent({
  name: $prefix + "Input",
  inheritAttrs: false,
  props: _extends({}, $props, {
    _constants: {
      type: Object,
      default: function _default() {
        return $constants;
      }
    },
    name: String,
    size: String,
    form: String,
    label: String,
    height: Number,
    resize: String,
    tabindex: {
      type: String,
      default: "1"
    },
    disabled: Boolean,
    readonly: Boolean,
    suffixIcon: [Object, String],
    prefixIcon: [Object, String],
    modelValue: [String, Number],
    type: {
      type: String,
      default: "text"
    },
    vertical: {
      type: Boolean,
      default: false
    },
    selectMenu: {
      type: Array,
      default: function _default2() {
        return [];
      }
    },
    ellipsis: {
      type: Boolean,
      default: false
    },
    contentStyle: {
      type: Object,
      default: function _default3() {
        return {};
      }
    },
    isSelect: {
      type: Boolean,
      default: false
    },
    mobileTips: String,
    counter: {
      type: Boolean,
      default: false
    },
    autosize: {
      type: [Boolean, Object],
      default: false
    },
    clearable: {
      type: Boolean,
      default: false
    },
    autocomplete: {
      type: String,
      default: "off"
    },
    showPassword: {
      type: Boolean,
      default: false
    },
    showWordLimit: {
      type: Boolean,
      default: false
    },
    showTitle: {
      type: Boolean,
      default: false
    },
    validateEvent: {
      type: Boolean,
      default: true
    },
    // mobile特有属性
    textareaTitle: {
      type: String,
      default: "标题"
    },
    displayOnly: {
      type: Boolean,
      default: false
    },
    displayOnlyContent: {
      type: String,
      default: ""
    },
    inputClass: {
      type: String,
      default: ""
    },
    frontClearIcon: {
      type: Boolean,
      default: false
    }
  }),
  setup: function setup(props, context) {
    return $setup({
      props,
      context,
      template
    });
  }
});
var version = "3.8.0";
Input.model = {
  prop: "modelValue",
  event: "update:modelValue"
};
Input.install = function(Vue) {
  Vue.component(Input.name, Input);
};
Input.version = version;
export {
  Input as default
};
