import { renderless, api } from "@xmweb-ui/vue-renderless/input/vue";
import { defineComponent, props, setup as _setup } from "@xmweb-ui/vue-common";
import { iconOperationfaild, iconChevronRight, iconEyeopen } from "@xmweb-ui/vue-icon";
import ActionSheet from "@xmweb-ui/vue-action-sheet";
import "@xmweb-ui/vue-theme-mobile/input/index.css";
import { resolveComponent, openBlock, createElementBlock, normalizeClass, Fragment, renderSlot, createCommentVNode, mergeProps, createBlock, resolveDynamicComponent, createElementVNode, withModifiers, toDisplayString, normalizeStyle, createVNode } from "vue";
function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it)
    return (it = it.call(o)).next.bind(it);
  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it)
      o = it;
    var i = 0;
    return function() {
      if (i >= o.length)
        return { done: true };
      return { done: false, value: o[i++] };
    };
  }
  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor)
    n = o.constructor.name;
  if (n === "Map" || n === "Set")
    return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length)
    len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++)
    arr2[i] = arr[i];
  return arr2;
}
var _export_sfc = function _export_sfc2(sfc, props) {
  var target = sfc.__vccOpts || sfc;
  for (var _iterator = _createForOfIteratorHelperLoose(props), _step; !(_step = _iterator()).done; ) {
    var _step$value = _step.value, key = _step$value[0], val = _step$value[1];
    target[key] = val;
  }
  return target;
};

var _sfc_main = defineComponent({
  inheritAttrs: false,
  emits: ["update:modelValue", "change", "clear", "focus", "blur", "keyup", "keydown", "paste", "mouseenter", "mouseleave"],
  components: {
    IconOperationfaild: iconOperationfaild(),
    IconChevronRight: iconChevronRight(),
    IconEyeopen: iconEyeopen(),
    XmActionSheet: ActionSheet
  },
  props: [].concat(props, ["name", "form", "selectMenu", "ellipsis", "contentStyle", "labelWidth", "mobileTips", "isSelect", "type", "label", "modelValue", "disabled", "readonly", "clearable", "maxlength", "suffixIcon", "prefixIcon", "autocomplete", "showPassword", "validateEvent", "showWordLimit", "showTitle", "textareaTitle", "counter", "autosize", "tabindex"]),
  setup: function setup(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var _hoisted_1 = {
  key: 0,
  class: "xm-mobile-input-group__prepend"
};
var _hoisted_2 = ["name", "tabindex", "type", "disabled", "readonly", "autocomplete", "aria-label"];
var _hoisted_3 = {
  key: 2,
  class: "xm-mobile-input__prefix"
};
var _hoisted_4 = {
  key: 3,
  class: "xm-mobile-input__suffix"
};
var _hoisted_5 = {
  class: "xm-mobile-input__suffix-inner"
};
var _hoisted_6 = {
  key: 3,
  class: "xm-mobile-input__count"
};
var _hoisted_7 = {
  class: "xm-mobile-input__count-inner"
};
var _hoisted_8 = {
  key: 4,
  class: "xm-mobile-input-group__append"
};
var _hoisted_9 = {
  class: "xm-mobile-input-form"
};
var _hoisted_10 = ["disabled", "value", "name", "aria-label", "tabindex"];
var _hoisted_11 = ["type", "name", "tabindex", "disabled", "readonly", "aria-label"];
var _hoisted_12 = {
  key: 0,
  class: "xm-mobile-input-form__tips"
};
var _hoisted_13 = {
  key: 2,
  class: "xm-mobile-textarea__title"
};
var _hoisted_14 = {
  key: 3,
  class: "xm-mobile-textarea__content"
};
var _hoisted_15 = ["name", "tabindex", "disabled", "readonly", "autocomplete", "aria-label"];
var _hoisted_16 = {
  key: 5,
  class: "xm-mobile-textarea__count"
};
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_icon_operationfaild = resolveComponent("icon-operationfaild");
  var _component_icon_eyeopen = resolveComponent("icon-eyeopen");
  var _component_IconChevronRight = resolveComponent("IconChevronRight");
  var _component_xm_action_sheet = resolveComponent("xm-action-sheet");
  return openBlock(), createElementBlock(
    "div",
    {
      class: normalizeClass([_ctx.type === "textarea" ? "xm-mobile-textarea" : "xm-mobile-input", _ctx.state.inputSize ? "xm-mobile-input-" + _ctx.state.inputSize : "", {
        "is-disabled": _ctx.state.inputDisabled,
        "is-exceed": _ctx.state.inputExceed,
        "is-showtitle": _ctx.showTitle && _ctx.type === "textarea",
        "is-showcontent": _ctx.slots.content && _ctx.type === "textarea",
        "is-showlimit": _ctx.state.isWordLimitVisible && _ctx.type === "textarea",
        "xm-mobile-input-group": _ctx.slots.prepend || _ctx.slots.append,
        "xm-mobile-input-group-append": _ctx.slots.append,
        "xm-mobile-input-group-prepend": _ctx.slots.prepend,
        "xm-mobile-input-prefix": _ctx.slots.prefix || _ctx.prefixIcon,
        "xm-mobile-input-suffix": _ctx.slots.suffix || _ctx.suffixIcon || _ctx.clearable || _ctx.showPassword
      }]),
      onMouseenter: _cache[27] || (_cache[27] = function($event) {
        return _ctx.state.hovering = true;
      }),
      onMouseleave: _cache[28] || (_cache[28] = function($event) {
        return _ctx.state.hovering = false;
      })
    },
    [_ctx.type !== "textarea" && _ctx.type !== "form" ? (openBlock(), createElementBlock(
      Fragment,
      {
        key: 0
      },
      [_ctx.slots.prepend ? (openBlock(), createElementBlock("div", _hoisted_1, [renderSlot(_ctx.$slots, "prepend")])) : createCommentVNode("v-if", true), _ctx.type !== "textarea" ? (openBlock(), createElementBlock("input", mergeProps({
        key: 1,
        ref: "input",
        name: _ctx.name
      }, _ctx.a(_ctx.$attrs, ["size", "class", "style", "^onw+"]), {
        class: "xm-mobile-input__inner",
        tabindex: _ctx.tabindex,
        type: _ctx.showPassword ? _ctx.state.passwordVisible ? "text" : "password" : _ctx.type,
        disabled: _ctx.state.inputDisabled,
        readonly: _ctx.readonly,
        autocomplete: _ctx.autocomplete,
        onCompositionstart: _cache[0] || (_cache[0] = function() {
          return _ctx.handleCompositionStart && _ctx.handleCompositionStart.apply(_ctx, arguments);
        }),
        onCompositionupdate: _cache[1] || (_cache[1] = function() {
          return _ctx.handleCompositionUpdate && _ctx.handleCompositionUpdate.apply(_ctx, arguments);
        }),
        onCompositionend: _cache[2] || (_cache[2] = function() {
          return _ctx.handleCompositionEnd && _ctx.handleCompositionEnd.apply(_ctx, arguments);
        }),
        onInput: _cache[3] || (_cache[3] = function() {
          return _ctx.handleInput && _ctx.handleInput.apply(_ctx, arguments);
        }),
        onFocus: _cache[4] || (_cache[4] = function() {
          return _ctx.handleFocus && _ctx.handleFocus.apply(_ctx, arguments);
        }),
        onBlur: _cache[5] || (_cache[5] = function() {
          return _ctx.handleBlur && _ctx.handleBlur.apply(_ctx, arguments);
        }),
        onChange: _cache[6] || (_cache[6] = function() {
          return _ctx.handleChange && _ctx.handleChange.apply(_ctx, arguments);
        }),
        "aria-label": _ctx.label
      }), null, 16, _hoisted_2)) : createCommentVNode("v-if", true), _ctx.slots.prefix || _ctx.prefixIcon ? (openBlock(), createElementBlock("span", _hoisted_3, [renderSlot(_ctx.$slots, "prefix"), _ctx.prefixIcon ? (openBlock(), createBlock(resolveDynamicComponent(_ctx.prefixIcon), {
        key: 0,
        class: "xm-mobile-input__icon"
      })) : createCommentVNode("v-if", true)])) : createCommentVNode("v-if", true), _ctx.getSuffixVisible() ? (openBlock(), createElementBlock("span", _hoisted_4, [createElementVNode("span", _hoisted_5, [!_ctx.state.showClear || !_ctx.state.showPwdVisible || !_ctx.state.isWordLimitVisible ? (openBlock(), createElementBlock(
        Fragment,
        {
          key: 0
        },
        [renderSlot(_ctx.$slots, "suffix"), _ctx.suffixIcon ? (openBlock(), createBlock(resolveDynamicComponent(_ctx.suffixIcon), {
          key: 0,
          class: "xm-mobile-input__icon"
        })) : createCommentVNode("v-if", true)],
        64
        /* STABLE_FRAGMENT */
      )) : createCommentVNode("v-if", true), _ctx.state.showClear ? (openBlock(), createBlock(_component_icon_operationfaild, {
        key: 1,
        class: "xm-mobile-input__icon xm-mobile-input__clear",
        onMousedown: _cache[7] || (_cache[7] = withModifiers(function() {
        }, ["prevent"])),
        onClick: _ctx.clear
      }, null, 8, ["onClick"])) : createCommentVNode("v-if", true), _ctx.state.showPwdVisible ? (openBlock(), createBlock(_component_icon_eyeopen, {
        key: 2,
        class: "xm-mobile-input__icon",
        onClick: _ctx.handlePasswordVisible
      }, null, 8, ["onClick"])) : createCommentVNode("v-if", true), _ctx.state.isWordLimitVisible ? (openBlock(), createElementBlock("span", _hoisted_6, [createElementVNode(
        "span",
        _hoisted_7,
        toDisplayString(_ctx.state.showWordLimit ? _ctx.state.textLength + "/" + _ctx.state.upperLimit : _ctx.state.textLength),
        1
        /* TEXT */
      )])) : createCommentVNode("v-if", true)]), _ctx.state.validateState ? (openBlock(), createElementBlock(
        "i",
        {
          key: 0,
          class: normalizeClass(["xm-mobile-input__icon", ["xm-mobile-input__validateIcon", _ctx.validateIcon]])
        },
        null,
        2
        /* CLASS */
      )) : createCommentVNode("v-if", true)])) : createCommentVNode("v-if", true), _ctx.slots.append ? (openBlock(), createElementBlock("div", _hoisted_8, [renderSlot(_ctx.$slots, "append")])) : createCommentVNode("v-if", true)],
      64
      /* STABLE_FRAGMENT */
    )) : createCommentVNode("v-if", true), _ctx.type === "form" ? (openBlock(), createElementBlock(
      Fragment,
      {
        key: 1
      },
      [createElementVNode("div", _hoisted_9, [_ctx.isSelect ? (openBlock(), createElementBlock("div", {
        key: 0,
        class: "xm-mobile-input-form__select",
        onClick: _cache[10] || (_cache[10] = function() {
          return _ctx.showBox && _ctx.showBox.apply(_ctx, arguments);
        })
      }, [createElementVNode("input", mergeProps({
        type: "text",
        disabled: _ctx.state.inputDisabled,
        value: _ctx.state.checkedLable
      }, _ctx.a(_ctx.$attrs, ["size", "class", "style", "^on[A-Z]"]), {
        onInput: _cache[8] || (_cache[8] = function() {
          return _ctx.handleInput && _ctx.handleInput.apply(_ctx, arguments);
        }),
        name: _ctx.name,
        onChange: _cache[9] || (_cache[9] = function() {
          return _ctx.handleChange && _ctx.handleChange.apply(_ctx, arguments);
        }),
        "aria-label": _ctx.label,
        readonly: "",
        class: "xm-mobile-input-form__input xm-mobile-input__inner",
        tabindex: _ctx.tabindex
      }), null, 16, _hoisted_10), createElementVNode(
        "div",
        {
          class: "xm-mobile-input-form__icon",
          style: normalizeStyle({
            transform: _ctx.state.boxVisibility ? "rotate(90deg)" : "none"
          })
        },
        [createVNode(_component_IconChevronRight)],
        4
        /* STYLE */
      )])) : (openBlock(), createElementBlock("input", mergeProps({
        key: 1,
        ref: "input"
      }, _ctx.a(_ctx.$attrs, ["size", "class", "style", "^on[A-Z]"]), {
        type: _ctx.showPassword ? _ctx.state.passwordVisible ? "text" : "password" : "text",
        name: _ctx.name,
        class: "xm-mobile-input-form__input xm-mobile-input__inner",
        tabindex: _ctx.tabindex,
        disabled: _ctx.state.inputDisabled,
        readonly: _ctx.readonly,
        onCompositionstart: _cache[11] || (_cache[11] = function() {
          return _ctx.handleCompositionStart && _ctx.handleCompositionStart.apply(_ctx, arguments);
        }),
        onCompositionupdate: _cache[12] || (_cache[12] = function() {
          return _ctx.handleCompositionUpdate && _ctx.handleCompositionUpdate.apply(_ctx, arguments);
        }),
        onCompositionend: _cache[13] || (_cache[13] = function() {
          return _ctx.handleCompositionEnd && _ctx.handleCompositionEnd.apply(_ctx, arguments);
        }),
        onInput: _cache[14] || (_cache[14] = function() {
          return _ctx.handleInput && _ctx.handleInput.apply(_ctx, arguments);
        }),
        onFocus: _cache[15] || (_cache[15] = function() {
          return _ctx.handleFocus && _ctx.handleFocus.apply(_ctx, arguments);
        }),
        onBlur: _cache[16] || (_cache[16] = function() {
          return _ctx.handleBlur && _ctx.handleBlur.apply(_ctx, arguments);
        }),
        onChange: _cache[17] || (_cache[17] = function() {
          return _ctx.handleChange && _ctx.handleChange.apply(_ctx, arguments);
        }),
        "aria-label": _ctx.label
      }), null, 16, _hoisted_11)), createVNode(_component_xm_action_sheet, {
        modelValue: _ctx.state.sheetvalue,
        "onUpdate:modelValue": _cache[18] || (_cache[18] = function($event) {
          return _ctx.state.sheetvalue = $event;
        }),
        menus: _ctx.selectMenu,
        ellipsis: _ctx.ellipsis,
        contentStyle: _ctx.contentStyle,
        visible: _ctx.state.boxVisibility,
        "onUpdate:visible": _cache[19] || (_cache[19] = function($event) {
          return _ctx.state.boxVisibility = $event;
        })
      }, null, 8, ["modelValue", "menus", "ellipsis", "contentStyle", "visible"])]), _ctx.mobileTips ? (openBlock(), createElementBlock(
        "div",
        _hoisted_12,
        toDisplayString(_ctx.mobileTips),
        1
        /* TEXT */
      )) : createCommentVNode("v-if", true)],
      64
      /* STABLE_FRAGMENT */
    )) : createCommentVNode("v-if", true), _ctx.showTitle && _ctx.type === "textarea" ? (openBlock(), createElementBlock(
      "div",
      _hoisted_13,
      toDisplayString(_ctx.textareaTitle),
      1
      /* TEXT */
    )) : createCommentVNode("v-if", true), _ctx.slots.content && _ctx.type === "textarea" ? (openBlock(), createElementBlock("div", _hoisted_14, [renderSlot(_ctx.$slots, "content")])) : createCommentVNode("v-if", true), _ctx.type === "textarea" ? (openBlock(), createElementBlock("textarea", mergeProps({
      key: 4,
      ref: "textarea",
      name: _ctx.name
    }, _ctx.a(_ctx.$attrs, ["type", "class", "style", "^on[A-Z]"]), {
      class: "xm-mobile-textarea__inner",
      tabindex: _ctx.tabindex,
      onCompositionstart: _cache[20] || (_cache[20] = function() {
        return _ctx.handleCompositionStart && _ctx.handleCompositionStart.apply(_ctx, arguments);
      }),
      onCompositionupdate: _cache[21] || (_cache[21] = function() {
        return _ctx.handleCompositionUpdate && _ctx.handleCompositionUpdate.apply(_ctx, arguments);
      }),
      onCompositionend: _cache[22] || (_cache[22] = function() {
        return _ctx.handleCompositionEnd && _ctx.handleCompositionEnd.apply(_ctx, arguments);
      }),
      onInput: _cache[23] || (_cache[23] = function() {
        return _ctx.handleInput && _ctx.handleInput.apply(_ctx, arguments);
      }),
      disabled: _ctx.state.inputDisabled,
      readonly: _ctx.readonly,
      autocomplete: _ctx.autocomplete,
      style: _ctx.state.textareaStyle,
      onFocus: _cache[24] || (_cache[24] = function() {
        return _ctx.handleFocus && _ctx.handleFocus.apply(_ctx, arguments);
      }),
      onBlur: _cache[25] || (_cache[25] = function() {
        return _ctx.handleBlur && _ctx.handleBlur.apply(_ctx, arguments);
      }),
      onChange: _cache[26] || (_cache[26] = function() {
        return _ctx.handleChange && _ctx.handleChange.apply(_ctx, arguments);
      }),
      "aria-label": _ctx.label
    }), "\n    ", 16, _hoisted_15)) : createCommentVNode("v-if", true), _ctx.state.isWordLimitVisible && _ctx.type === "textarea" ? (openBlock(), createElementBlock(
      "span",
      _hoisted_16,
      toDisplayString(_ctx.state.showWordLimit ? _ctx.state.textLength + "/" + _ctx.state.upperLimit : _ctx.state.textLength),
      1
      /* TEXT */
    )) : createCommentVNode("v-if", true)],
    34
    /* CLASS, HYDRATE_EVENTS */
  );
}
var mobile = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
export {
  mobile as default
};
